From de8659d0005b985e46ff105180d3b34c39d3f8a9 Mon Sep 17 00:00:00 2001
From: Gerald Combs <gerald@wireshark.org>
Date: Wed, 4 Jan 2023 10:11:32 -0800
Subject: GNW: Ensure that tvbuff proto data has the proper scope.

Add security tvbuffs to our proto data using pinfo->pool.
Fixes #18779.

(cherry picked from commit 693dc40936a9eeac0e1c10ff496b3d327e25642b)
---
 epan/dissectors/packet-geonw.c | 9 +++++----
 1 file changed, 5 insertions(+), 4 deletions(-)

diff --git a/epan/dissectors/packet-geonw.c b/epan/dissectors/packet-geonw.c
index f99cd4f645..992e2fca9b 100644
--- a/epan/dissectors/packet-geonw.c
+++ b/epan/dissectors/packet-geonw.c
@@ -148,6 +148,8 @@ void proto_register_geonw(void);
 
 #define TST_MAX 0xffffffff
 
+#define SEC_TVB_KEY 0
+
 /*
  * Variables
  */
@@ -1913,7 +1915,7 @@ dissect_sec_payload(tvbuff_t *tvb, gint *offset, packet_info *pinfo, proto_tree
                 param_len = dissect_sec_var_len(tvb, offset, pinfo, field_tree);
                 if (param_len) {
                     tvbuff_t *next_tvb = tvb_new_subset_length(tvb, *offset, param_len);
-                    p_add_proto_data(wmem_file_scope(), pinfo, proto_geonw, 0, next_tvb);
+                    p_add_proto_data(pinfo->pool, pinfo, proto_geonw, SEC_TVB_KEY, next_tvb);
                 }
                 *offset += param_len;
                 break;
@@ -2116,7 +2118,7 @@ static int
 dissect_sgeonw(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree _U_, void *data _U_)
 {
     // Just store the tvbuff for later, as it is embedded inside a secured geonetworking packet
-    p_add_proto_data(wmem_file_scope(), pinfo, proto_geonw, 0, tvb);
+    p_add_proto_data(pinfo->pool, pinfo, proto_geonw, SEC_TVB_KEY, tvb);
 
     return tvb_reported_length(tvb);
 }
@@ -2229,7 +2231,7 @@ dissect_geonw(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U
 
     if (bh_next_header == BH_NH_SECURED_PKT) {
         dissect_secured_message(tvb, offset, pinfo, geonw_tree, NULL);
-        tvbuff_t *next_tvb = (tvbuff_t*)p_get_proto_data(wmem_file_scope(), pinfo, proto_geonw, 0);
+        tvbuff_t *next_tvb = (tvbuff_t*)p_get_proto_data(pinfo->pool, pinfo, proto_geonw, SEC_TVB_KEY);
         if (next_tvb) {
             tvb = next_tvb;
             bh_next_header = BH_NH_COMMON_HDR;
@@ -2262,7 +2264,6 @@ dissect_geonw(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U
                 default:
                     hdr_len = -1;
             }
-            p_add_proto_data(wmem_file_scope(), pinfo, proto_geonw, 0, NULL);
         }
     }
 
-- 
2.30.2

